/**********************************************************
** RS232 Driver for STR91x Microcontroller
**
** Created Sept 13, 2006
**
** By James Patchell
**********************************************************/

#ifndef RS232__H
#define RS232__H

#include "91x_map.h"
#include "task.h"
#include "cio.h"

//------------------------------------------
// UART Handles
//------------------------------------------

enum RS232_Handle {RS232PORT0,RS232PORT1,RS232PORT2};

//------------------------------------------
// RS232 IO descriptor
//------------------------------------------

#define RS232_BUFFSIZE	256

typedef struct {
	short Head;   //head pointer for circular buffer
	short Tail;   //tail pointer for circular buffer
	short nChar;  //number of characters in buffer
	short Size;	//size of buffer
	char *pBuff;  //pointer to buffer
	long Errors;
	UART_TypeDef *Uart;
	ECB *Sem;
	ECB *Block;
}IOREC;

/*
extern void RInit(short Handle,long Baudrate,short parity,short bits);
extern int RGet(short Handle);
extern void RPut(short Handle,short c);
extern short RStatus(short Handle, short Type);
extern void RWrite(short Handle,char *b,int n);
*/
extern void RRecIrqHandler(short Handle);
extern void RSendIrqHandler(short Handle);
extern void SetPutChar(IOCB *I);

extern long RS232Init(void);

#ifndef BIT
#define BIT(x)	(1 << (x))
#endif

#define RS232_TYPE_RECIEVE	0
#define RS232_TYPE_TRANSMIT	1

#endif
