/******************** (C) COPYRIGHT 2006 STMicroelectronics ********************
* File Name          : main.c
* Author             : MCD Application Team
* Date First Issued  : 05/18/2006 : Version 1.0
* Description        : Main program body
* TASK SWAPPING Experiments....
********************************************************************************
* History:
* 05/24/2006 : Version 1.1
* 05/18/2006 : Version 1.0
********************************************************************************
* THE PRESENT SOFTWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
* AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY DIRECT,
* INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE
* CONTENT OF SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING
* INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*******************************************************************************/

/* Standard include ----------------------------------------------------------*/
#include <stdio.h>
#include "main.h"
#include "enable.h"
#include "cio.h"
#include "rs232.h"
#include "malloc_m.h"
#include "BlockAlloc.h"

extern void InitTasks(void);

/* Include of other module interface headers ---------------------------------*/
/* Local includes ------------------------------------------------------------*/
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
 GPIO_InitTypeDef GPIO_InitStructure;
 ADC_InitTypeDef  ADC_InitStructure;
 WIU_InitTypeDef  WIU_InitStructure;
 extern TIM_InitTypeDef  TIM_InitStructure;
  u16 LedPulse = 0;
  
 unsigned int centaine(unsigned int val){
   unsigned int valCopy;
   valCopy = val % 1000;
   return((valCopy/100) + 0x30);
   }
 unsigned int dixaine(unsigned int val){
  unsigned int valCopy;
  valCopy = val % 100;
  return((valCopy/10) + 0x30);
 }		
 unsigned int unite(unsigned int val){
  unsigned int valCopy;
  valCopy = val % 100;
  return((valCopy%10) + 0x30);
 }  


/* Private functions ---------------------------------------------------------*/
/*******************************************************************************
* Function Name  : main
* Description    : Main program
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void main()
{
#ifdef DEBUG
    debug();
#endif
  /*Initialize the demonstration application*/
	Disable();
	Demo_Init();
	CioInit();			//initialize I/O Manager
	InitMalloc();		//initialize memory manager
	InitBlockAlloc(64,8);	//initialize block memory manager
	RS232Init();			//initialize RS232 device driver
  /* Enable WIU interrupt*/
	WavePlayer_Start();  
	VIC_ITCmd(WIU_ITLine, ENABLE); 
	InitTasks();
  /* Start playing Osiris wave */
 	while(1){
	}  
}
/*******************************************************************************
* Function Name  : Demo_Init
* Description    : Initializes the demonstration application.
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void  Demo_Init(void)
{   
/*----------------------- System Clock Config --------------------------------*/
  
  FMI_BankRemapConfig(4, 2, 0, 0x80000); /* Set Flash banks size & address */
  FMI_Config(FMI_READ_WAIT_STATE_2, FMI_WRITE_WAIT_STATE_0, FMI_PWD_ENABLE,\
             FMI_LVD_ENABLE, FMI_FREQ_HIGH); /* FMI Waite States */
  
  /* Set the PCLK Clock to MCLK/2 */
  SCU_PCLKDivisorConfig(SCU_PCLK_Div2);
 
  SCU_PLLFactorsConfig(192, 25, 2); /* Configure Factors FPLL = 96MHz */
  SCU_PLLCmd(ENABLE);
  SCU_MCLKSourceConfig(SCU_MCLK_PLL);  
 
/*--------------------- Peripherals Clock Enable -----------------------------*/
  
  /* Enable TIM0 clock  */
  SCU_APBPeriphClockConfig(__TIM01, ENABLE);
  TIM_DeInit(TIM0);
  
  /* Enable TIM2 and TIM3 clock  */
  SCU_APBPeriphClockConfig(__TIM23, ENABLE);
  TIM_DeInit(TIM2);
  TIM_DeInit(TIM3);
  
   /* Enable ADC clock */
  SCU_APBPeriphClockConfig(__ADC, ENABLE);   
  ADC_DeInit();                               

  /* Enable VIC clock */
  SCU_AHBPeriphClockConfig(__VIC, ENABLE);
  VIC_DeInit();
  
  /* Enable WIU clock */
  SCU_APBPeriphClockConfig(__WIU, ENABLE);
  WIU_DeInit();
  
   /* Enable GPIO3 clock */
  SCU_APBPeriphClockConfig(__GPIO3, ENABLE);
  GPIO_DeInit(GPIO3);
  
  /* Enable GPIO4 clock */
  SCU_APBPeriphClockConfig(__GPIO4, ENABLE);
  GPIO_DeInit(GPIO4);
 
  SCU_APBPeriphClockConfig(__GPIO5, ENABLE);
  GPIO_DeInit(GPIO5);
 
   /* Enable GPIO6 clock */
  SCU_APBPeriphClockConfig(__GPIO6, ENABLE);
  GPIO_DeInit(GPIO6);
  
  /* Enable GPIO7 clock */
  SCU_APBPeriphClockConfig(__GPIO7, ENABLE);
  GPIO_DeInit(GPIO7);
  
/*--------------------- Drivers Initialization -------------------------------*/
  
  /* Initialize wave player driver */
  WavePlayer_Init();
  SystemTimer_Init();

/*------------------------ GPIOs Configuration -------------------------------*/  
  
  /* GPIO7 pin 5 and 6 configuration */
  GPIO_StructInit(&GPIO_InitStructure);
  GPIO_InitStructure.GPIO_Direction = GPIO_PinInput;
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5|GPIO_Pin_6;
  GPIO_InitStructure.GPIO_Type = GPIO_Type_PushPull ;
  GPIO_Init (GPIO7, &GPIO_InitStructure);  
  
  /* Configure the GPIO4 pin 5 as analog input */
  GPIO_ANAPinConfig(GPIO_ANAChannel5, ENABLE); 
  
/*----------------------------ADC Configuration------------------------------*/ 
  
  ADC_StructInit(&ADC_InitStructure);
  ADC_InitStructure.ADC_Channel_5_Mode = ADC_NoThreshold_Conversion;
  ADC_InitStructure.ADC_Select_Channel = ADC_Channel_5;
  ADC_InitStructure.ADC_Scan_Mode = DISABLE;
  ADC_InitStructure.ADC_Conversion_Mode = ADC_Continuous_Mode;
  /* Enable the ADC */
  ADC_Cmd(ENABLE);
  /* Prescaler config */
  ADC_PrescalerConfig(0x4);
  /* Configure the ADC */
  ADC_Init(&ADC_InitStructure);   
  
/*------------------------ WIU Configuration ---------------------------------*/
 
  /* WIU Line 29 configuration */
  WIU_ClearITPendingBit(WIU_Line29);
  WIU_InitStructure.WIU_Mode = WIU_Mode_Interrupt;
  WIU_InitStructure.WIU_Line = WIU_Line29;
  WIU_InitStructure.WIU_TriggerEdge = WIU_FallingEdge;
  WIU_Init(&WIU_InitStructure);
  
  /* WIU Line 30 configuration */
  WIU_ClearITPendingBit(WIU_Line30);
  WIU_InitStructure.WIU_Mode = WIU_Mode_Interrupt;
  WIU_InitStructure.WIU_Line = WIU_Line30;
  WIU_InitStructure.WIU_TriggerEdge = WIU_FallingEdge;
  WIU_Init(&WIU_InitStructure);

/*------------------------ VIC Configuration ---------------------------------*/ 
  
	VIC_Config(WIU_ITLine, VIC_IRQ, 0);
	VIC_Config(TIM0_ITLine, VIC_IRQ, 1);
	VIC_ITCmd(TIM0_ITLine, ENABLE); 
	//-----------timer 2-----------------?
	VIC_Config(TIM2_ITLine,VIC_IRQ,2);
	VIC_ITCmd(TIM2_ITLine,ENABLE);
 }
/*******************************************************************************
* Function Name  : SystemTimer_Init
* Description    : Implements a system timer that generates an event each 100
*                  millisecondes (100ms).
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void SystemTimer_Init(void)
{  
  TIM_StructInit(&TIM_InitStructure);
  TIM_InitStructure.TIM_Mode = TIM_OCM_CHANNEL_1;
  TIM_InitStructure.TIM_OC1_Modes = TIM_TIMING;
  TIM_InitStructure.TIM_Clock_Source = TIM_CLK_APB;
  TIM_InitStructure.TIM_Prescaler = 0x10;
  TIM_InitStructure.TIM_Pulse_Length_1 = 0x753;
  /* Initialize the Timer 2 */
  TIM_Init (TIM2, &TIM_InitStructure);
  /* Enable the Timer Output Compare 1 interrupt */
  TIM_ITConfig(TIM2, TIM_IT_OC1, ENABLE);
  /* Start the Timer counter */
  TIM_CounterCmd(TIM2, TIM_START);
}

/******************* (C) COPYRIGHT 2006 STMicroelectronics *****END OF FILE****/
